
TOPDIR 		= ../../..
SOURCE		= .
VEC		= vec
TARGET		= $(TOPDIR)/target/em
EXECUTABLES	= $(TOPDIR)/target/bin
LIBRARIES	= $(TOPDIR)/target/lib
BIN		= $(TOP)/bin
TMP		= /tmp

EM_LD		=
GEN_LDFLAGS	=
EM_CFLAGS	=
GEN_CFLAGS	=

EXT		= o
CC		= cc
MV		= mv
LIB		= -L$(LIBRARIES) -lm -lson
RM		= rm -f
OPTIMIZE	=
OPTS		=
HEAD_INCLUDE	= -I../include
VEC_OPTS	= 
EM_OPTS		= 
EMHH_OPTS	= 
# SHELL		= /bin/sh	# not defined due to DOS
PRODUCTS	= $(EXECUTABLES)/em $(TARGET)/jutil.$(EXT)

########################## OPTIONS FOR CRAY
#
#          OPTS1 =  -h vreport  -h olevel_3 -h ivdep
#          OPTS2 =  -h novector
#          OPTS3 =  -h vreport  -h olevel_3
#         TARGET = .
#    EXECUTABLES = .
#        DEFINES = -DUNIX -DCRAY
#            BIN = .
#             MV = echo         
#           OPTS = -DNO_EM_SECURITY -DMALLOC_H

########################## OPTIONS FOR DOS

DVX			= C:/dvx
HIGHC			= C:/highc
PHAR386			= C:/phar386
COPROCESSOR		= 387
CC		= hc386
LD		= 386link
BIND		= bind386
BIND_MODULE	= $(PHAR386)/bin/run386b.exe
MFG		= 
TARGET		= $(MFG)/target/em
EXECUTABLES	= $(MFG)/target/bin
EXT		= obj
PRODUCTS	= $(EXECUTABLES)/em.exe $(TARGET)/jutil.$(EXT)
MV		= mv
DEFINES		= -DDOS
GEN_CFLAGS	= @cflags.rsp -f$(COPROCESSOR)
LIB		= 


############# LOCAL DEFINITIONS - BEGIN

#### SUN
# DEFINES = -DUNIX -DSUN -DSPARC
# OPTS = -g -fsingle
# EM_LD = -Bstatic
# MACH=andy

#### HP
# DEFINES = -DUNIX -DHP -DHP700
# OPTS = -g  -Aa
# EM_LD = -g
# OPTS = -O  -Aa
# EM_LD = -O
# MACH=laura

# TARGET = .
# EXECUTABLES = .
# BIN = .
# MV = echo
# PRODUCTS = em
# HEAD_INCLUDE = -I/$(MACH)/local/include
# LIB = -L/$(MACH)/local/lib -lm -lson

############# LOCAL DEFINITIONS END 



CFLAGS = $(CDBUGFLAGS) $(HEAD_INCLUDE) $(STD_DEFINES) $(DEFINES) \
	  $(OPTS) $(OPTIMIZE) $(EM_CFLAGS) $(GEN_CFLAGS)
LDFLAGS = $(OPTIMZE) $(LIB) $(EM_LD) $(GEN_LDFLAGS)
RM_CMD = $(RM) $(TARGET)/*.$(EXT) $(PRODUCTS) $(TARGET)/*.tags

SECURITY_DEPEND = \
		keyfile.h \
		unlcki_p.h \
		crypt.i \
		crypt2.i \
		date.i \
		getnode.i \
		rkeyfile.i \
		security.i \
		unnode.i \
		wkeystr.i

EM_HEADERS = \
		em.typ  \
		hharray.h \
		$(VEC)/vec.h \
		$(VEC)/mat.h \
		$(VEC)/complex.h


## NOTE: em must be the first file and emex must be the last file compiled.
##       used in checksuming for DOS.

EM_OBJS =  \
		$(TARGET)/em.$(EXT) \
		$(TARGET)/emin.$(EXT) \
		$(TARGET)/emcheck.$(EXT) \
		$(TARGET)/emhead.$(EXT) \
		$(TARGET)/empoly.$(EXT) \
		$(TARGET)/readpoly.$(EXT) \
		$(TARGET)/eman.$(EXT) \
		$(TARGET)/emout.$(EXT) \
		$(TARGET)/sparm.$(EXT) \
		$(TARGET)/ptlist.$(EXT) \
		$(TARGET)/vecall.$(EXT) \
		$(TARGET)/polyutil.$(EXT) \
		$(TARGET)/chsm.$(EXT) \
		$(TARGET)/emhh.$(EXT) \
		$(TARGET)/emhb.$(EXT) \
		$(TARGET)/emhc.$(EXT) \
		$(TARGET)/qemhb.$(EXT) \
		$(TARGET)/qemhc.$(EXT) \
		$(TARGET)/msubutil.$(EXT) \
		$(TARGET)/version.$(EXT) \
		$(TARGET)/fmtnum.$(EXT) \
		$(TARGET)/annfile.$(EXT) \
		$(TARGET)/emex.$(EXT)

DOS_OBJS =  


EM_SRC =  \
		em.c \
		emin.c \
		emcheck.c \
		emhead.c \
		empoly.c \
		readpoly.c \
		eman.c \
		emout.c \
		sparm.c \
		ptlist.c \
		polyutil.c \
		chsm.c \
		emhh.c \
		emhb.c \
		emhc.c \
		qemhb.c \
		qemhc.c \
		msubutil.c \
		version.c \
		fmtnum.c \
		annfile.c \
		emex.c

VEC_SRC =  \
		vec/complex.c \
		vec/comptest.c \
		vec/cos.c \
		vec/fft.c \
		vec/mat.c \
		vec/matasm.c \
		vec/matcol.c \
		vec/matinv.c \
		vec/matmove.c \
		vec/matred.c \
		vec/mattest.c \
		vec/nfckvec.c \
		vec/nfnckvec.c \
		vec/nfvec.c \
		vec/sin.c \
		vec/ssmat.c \
		vec/vec.c \
		vec/vecacos.c \
		vec/vecadd.c \
		vec/vecasin.c \
		vec/vecatan.c \
		vec/vecchs.c \
		vec/vecconj.c \
		vec/veccos.c \
		vec/vecdiv.c \
		vec/vecdot.c \
		vec/vecexp.c \
		vec/vecffa.c \
		vec/vecffb.c \
		vec/vecln.c \
		vec/vecmove.c \
		vec/vecmult.c \
		vec/vecsadd.c \
		vec/vecsdiv.c \
		vec/vecsin.c \
		vec/vecsmult.c \
		vec/vecsqrt.c \
		vec/vecssub.c \
		vec/vecsub.c \
		vec/vecsum.c \
		vec/vectan.c \
		vec/vectest.c 



all::	$(PRODUCTS)

#################################
#           			#
#           BUILD EM	       	#
#           			#
#################################


em:	$(EXECUTABLES)/em

$(EXECUTABLES)/em:		$(EM_OBJS)
		$(CC) $(EM_OBJS) $(LDFLAGS) $(OPTS2) -o $(EXECUTABLES)/em

em.exec:
		$(CC) $(EM_OBJS) $(LDFLAGS) $(OPTS2) -o $(EXECUTABLES)/em

#################################
#           			#
#        DOS SUPPORT		#
#           			#
#################################

$(EXECUTABLES)/em.exe: $(EXECUTABLES)/em.exp
	$(BIND) $(BIND_MODULE) $(EXECUTABLES)/em.exp -exe $(EXECUTABLES)/em.exe

$(EXECUTABLES)/em.exp: $(EM_OBJS) $(DOS_OBJS) cflags.rsp link.rsp objs.rsp
	$(LD) @link.rsp @objs.rsp $(LDFLAGS) -exe $(EXECUTABLES)/em.exp

objs.rsp::
	echo $(EM_OBJS) $(DOS_OBJS) | dosobj > objs.rsp

link.rsp::
	> link.rsp
	echo -LIB $(HIGHC)/small/hc$(COPROCESSOR) >> link.rsp
	echo -LIB $(HIGHC)/small/hcloc          >> link.rsp
	echo -LIB $(HIGHC)/small/hc386          >> link.rsp
	echo -LIB $(HIGHC)/small/hcna           >> link.rsp
	echo -LIB C:/glenco/hl386hc.lib         >> link.rsp
	echo -STACK 40000                       >> link.rsp
	echo -cvsymbols                         >> link.rsp
	echo -priv                         	>> link.rsp 
	echo -LIB $(LIBRARIES)/libson          >> link.rsp

cflags.rsp::
	> cflags.rsp
	echo -O5                                >> cflags.rsp
	echo -Hoff=Low_level_scheduling         >> cflags.rsp
	echo -w                                 >> cflags.rsp
	echo -486                               >> cflags.rsp
	echo -Hnocopyr                          >> cflags.rsp
	echo -Hon=Pointers_compatible           >> cflags.rsp
	echo -Hon=Pointers_compatible_with_ints >> cflags.rsp
	echo -DMSDOS                            >> cflags.rsp
	echo -I$(DVX)/include                	>> cflags.rsp
	echo -I../include                	>> cflags.rsp 
	

#################################
#           			#
#        LINK ONLY		#
#           			#
#################################


em.obj:		$(EM_OBJS)



#################################
#           			#
#        LINK MODULES		#
#           			#
#################################

####
####
####   BUILD EM
####
####

$(TARGET)/msubutil.$(EXT): msubutil.c $(EM_HEADERS)
		$(CC) msubutil.c $(CFLAGS) $(OPTS2) -c
		$(MV) msubutil.$(EXT) $(TARGET)

$(TARGET)/polyutil.$(EXT): polyutil.c $(EM_HEADERS)
		$(CC) polyutil.c $(CFLAGS) $(OPTS2) -c
		$(MV) polyutil.$(EXT) $(TARGET)

$(TARGET)/chsm.$(EXT): chsm.c timeout.h $(EM_HEADERS)
		$(CC) chsm.c $(CFLAGS) $(OPTS2) -c
		$(MV) chsm.$(EXT) $(TARGET)

$(TARGET)/em.$(EXT):	em.c timeout.h $(EM_HEADERS)
		$(CC) em.c $(EM_OPTS) $(CFLAGS) $(OPTS2) -c
		$(MV) em.$(EXT) $(TARGET)

$(TARGET)/emin.$(EXT): emin.c $(EM_HEADERS) $(SECURITY_DEPEND)
		$(CC) emin.c $(CFLAGS) -c
		$(MV) emin.$(EXT) $(TARGET)
 
$(TARGET)/emcheck.$(EXT): emcheck.c $(EM_HEADERS) timeout.h
		$(CC) emcheck.c $(CFLAGS) $(OPTS2) -c
		$(MV) emcheck.$(EXT) $(TARGET)
 
$(TARGET)/emhead.$(EXT): emhead.c $(EM_HEADERS)
		$(CC) emhead.c $(CFLAGS) $(OPTS2) -c
		$(MV) emhead.$(EXT) $(TARGET)
 
$(TARGET)/empoly.$(EXT): empoly.c $(EM_HEADERS)
		$(CC) empoly.c $(CFLAGS) $(OPTS2) -c
		$(MV) empoly.$(EXT) $(TARGET)
 
$(TARGET)/readpoly.$(EXT): readpoly.c $(EM_HEADERS)
		$(CC) readpoly.c $(CFLAGS) $(OPTS2) -c
		$(MV) readpoly.$(EXT) $(TARGET)
 
$(TARGET)/eman.$(EXT): eman.c $(EM_HEADERS)
		$(CC) eman.c $(CFLAGS) $(OPTS1) -c
		$(MV) eman.$(EXT) $(TARGET)

$(TARGET)/emhh.$(EXT) : emhh.c emh.c emha.c qemha.c $(EM_HEADERS)
		$(CC) emhh.c $(EMHH_OPTS) $(CFLAGS) $(OPTS1) -c
		$(MV) emhh.$(EXT) $(TARGET)

$(TARGET)/emhb.$(EXT) : emhb.c $(EM_HEADERS)
		$(CC) emhb.c $(EMHH_OPTS) $(CFLAGS) $(OPTS1) -c
		$(MV) emhb.$(EXT) $(TARGET)

$(TARGET)/emhc.$(EXT) : emhc.c $(EM_HEADERS)
		$(CC) emhc.c $(EMHH_OPTS) $(CFLAGS) $(OPTS1) -c
		$(MV) emhc.$(EXT) $(TARGET)

$(TARGET)/qemhb.$(EXT) : qemhb.c $(EM_HEADERS)
		$(CC) qemhb.c $(EMHH_OPTS) $(CFLAGS) $(OPTS1) -c
		$(MV) qemhb.$(EXT) $(TARGET)

$(TARGET)/qemhc.$(EXT) : qemhc.c $(EM_HEADERS)
		$(CC) qemhc.c $(EMHH_OPTS) $(CFLAGS) $(OPTS1) -c
		$(MV) qemhc.$(EXT) $(TARGET)

$(TARGET)/emout.$(EXT) : emout.c $(EM_HEADERS)
		$(CC) emout.c $(CFLAGS) $(OPTS2) -c
		$(MV) emout.$(EXT) $(TARGET)

$(TARGET)/sparm.$(EXT) : sparm.c $(EM_HEADERS)
		$(CC) sparm.c $(CFLAGS) $(OPTS2) -c
		$(MV) sparm.$(EXT) $(TARGET)

$(TARGET)/ptlist.$(EXT) : ptlist.c $(EM_HEADERS)
		$(CC) ptlist.c $(CFLAGS) $(OPTS2) -c
		$(MV) ptlist.$(EXT) $(TARGET)

$(TARGET)/version.$(EXT): version.c version.h  sccs.h \
	$(VEC)/ssmat.c $(VEC)/complex.c
		$(CC) version.c $(CFLAGS) $(OPTS2) -c
		$(MV) version.$(EXT) $(TARGET)

$(TARGET)/vecall.$(EXT): $(VEC_SRC) $(EM_HEADERS)
		$(CC) vecall.c $(VEC_OPTS) $(CFLAGS) $(OPTS3) -c
		$(MV) vecall.$(EXT) $(TARGET)


$(TARGET)/fmtnum.$(EXT) : fmtnum.c $(EM_HEADERS)
		$(CC) fmtnum.c $(CFLAGS) $(OPTS2) -c
		$(MV) fmtnum.$(EXT) $(TARGET)

$(TARGET)/annfile.$(EXT) : annfile.c $(EM_HEADERS)
		$(CC) annfile.c $(CFLAGS) $(OPTS3) -c
		$(MV) annfile.$(EXT) $(TARGET)

$(TARGET)/emex.$(EXT) : emex.c timeout.h $(EM_HEADERS)
		$(CC) emex.c $(CFLAGS) $(OPTS3) -c
		$(MV) emex.$(EXT) $(TARGET)

####
####
####   BUILD jutil.o (Used in emvu)
####
####	NOTE: jutil.o is built here due to the high dependencies on em
####	      code.  This should be changed in future release
####
####

$(TARGET)/jutil.$(EXT) : jutil.c jxy.typ em.typ $(VEC)/vec.h $(VEC)/mat.h
		$(CC) jutil.c $(CFLAGS) $(OPTS3) -c
		$(MV) jutil.$(EXT) $(TARGET)

clean:
		$(RM) $(RM_CMD)

lint::
	lint $(DEFINES) $(STD_DEFINES) -DUNIX $(SRC)
	 

emvulib.inp: makefile $(SRC)
	echo "defineg DOS"		> emvulib.inp
	echo "defineg MALLOC_H"		>> emvulib.inp
	echo "defineg NO_EM_SECURITY"	>> emvulib.inp
	echo "defineg PWD_H"		>> emvulib.inp
	echo "ipath /base/src/include;c:/dvx/include;c:/c600/include" >> emvulib.inp
	echo "load jutil.c"		>> emvulib.inp
	echo "load vecall.c"		>> emvulib.inp
	echo "load sparm.c"		>> emvulib.inp
